#include "mex.h"
#include <stdio.h>
#include <iostream>
#include <time.h>
#include <stdlib.h>
#include <fstream>
#include <algorithm>
using namespace std;


//La Gateway funtion  alla fine del file!!!!!



int*HR;//set as global variable






///////////////////////
//typdefinitions
///////////////////////////


/////////////////////////
//Data structure
/////////////////////////	
   

	

	struct Statistic
	{
	   float wins;
	   float draws;
	   float Odd;
	   float PlayerHigherHand[10];
	   float OpponentHigherHand[10];
	 
	};




/////////////////////////////////
//global funcitons
///////////////////////////////////
	void RandNumbers(int* p,int N,int pmax,int pmin) ;
	void PrintNumbers(int* p,int N);
    void GameSimulation(int* KnownCard,int NumPlayers,int NumSimulation,Statistic* Stat);
     void GetDeck(int* Deck,bool* Picked);
    void RandGame(int* Deck,int N,int Nump);
      void ResetStat(Statistic* Stat);
	  void TestRandNumbers(int*p,int N);
	  void NormalizeStat(Statistic* Stat,float Ns);

//////////////////////////
//Global variables



void RandNumbers(int* p,int N,int pmax,int pmin) 
{//function to generate random points in pmin-pmax range



// loop to generate random points not normalized
    int i;//counter;

	pmax=pmax-pmin+1;//necessario per l'operatore %
    for (i=0;i<N;i++)
	{
		p[i]=pmin+rand()%pmax;
	}
	//debug
	//PrintNumbers(p,N);
	//TestRandNumbers(p,N);

}




void GetDeck(int* Deck,bool* Picked)
{   //This funtion generates a deck of cards. Cards are inticated as integer numbers from 1 to 52
	//Note Deck is an array of (52-knowncards) elements
    //Picked is a 52 elements boolean array, true if the card is known (or picked)

    int i;
	int c=0;

	for(i=0;i<52;i++)
	{
		if(! Picked[i])//only take unpicked
		{
	    Deck[c]=i+1;//plus one per avere le carte da 1 a 52;
		c++;
		}
		
		
		
	}

}


void RandGame(int* Deck,int N,int Nump)
{  
	//Permutes deck = generate a random game
	//N is the deck size, only unknown cards
	//Nump is the maximum number of permutation, only first nump card will be permuted=faster!!!

    int i;
    int j;
	int temp;
    
	//generetes random numbers
	int* r=new int[Nump];
    RandNumbers(r,Nump,N-1,0) ;
     


	//generates the permutation
	for (i=0;i<Nump;i++)
	{   
		j=r[i];

		//Swap Deck[i] Deck[j]
        temp=Deck[i];
		Deck[i]=Deck[j];
		Deck[j]=temp;
		
	}
	
	delete[]r;
}





void GameSimulation(int* KnownCard,int NumPlayers,int NumSimulation,Statistic* Stat)
{   
  //Known card is an integer array of numpalyers*2 + 5 elemnts, it indicats all possible known
	//known card in texas holdem game. unknown card are flagged as -1.
	//NumPlayers and NumSimulation is obvious, Stat is the store for statistics


   //Allocate memory

	bool Picked[52]={false};//detecs known/picked cards
    int numKnownCards=0;//NUmber of known cards
	int i,c,j,n;//counters
	

	float numTie;//number of ties
	int HighestRank;
	int Rank,myRank;
	int idwin,idwinmax;
	int rank5;//rank after 5cards evaluation
	



   srand( (unsigned)time( NULL ) );//seed the random generator 

	bool* Known=new bool[(NumPlayers*2+5)];//detecs from the possible known cards those that truly are known
    for(i=0;i<(NumPlayers*2+5);i++) Known[i]=false;//set to false;

    //Reset Statistics, make sure all values are zeros
	ResetStat(Stat);
	

 

	//counts known cards and generates the deck
	for (i=0;i<(NumPlayers*2+5);i++)
	{
		if (KnownCard[i]>0)//check if card is actually known
		{
            Picked[KnownCard[i]-1]=true;//yes it is 
            numKnownCards++;
			Known[i]=true;//it is known
		}

	}

    //Generates deck

	int* Deck=new int[52-numKnownCards];
	GetDeck(Deck,&Picked[0]);

     //Debug
	 //PrintCards(Deck,52-numKnownCards);


	 


	 //Run simulation 

	 for(n=0;n<NumSimulation;n++)
	 {
          //Permutes
		 RandGame(Deck,52-numKnownCards,NumPlayers*2+5);
		 //Debug
	    //PrintCards(Deck,52-numKnownCards);
         
		
		 //Give and evaluate table cards
		 c=0;//Deck counter
		 j=2;//Hand counter
		 rank5=53;//like the evaluator help says
		 for(i=NumPlayers*2;i<NumPlayers*2+5;i++)
		 {
			 if (Known[i])
			 {//if known evaluate with known card
				 rank5=HR[rank5+KnownCard[i]];
			 }
			 else
			 {//if unknown evaluate with deck card
                 rank5=HR[rank5+Deck[c]];
				 c++;
			 }
			 j++;
		 }
		 
	  


	 

		  //Now we can computes habd ranks
	    

		 //My rank
		    //My cards
		 (Known[0])?  myRank=HR[rank5+KnownCard[0]]  :     myRank=HR[rank5+Deck[c]],c++;
		 (Known[1])?  myRank=HR[myRank+KnownCard[1]]   :   myRank=HR[myRank+Deck[c]],c++;
		
		 idwin=myRank>>12;//gets my win id
	     
		 Stat->PlayerHigherHand[idwin]++;
          
		 //Debug
		 //printf("HandRank: %4.1d \n",idwin);
		

		  HighestRank=-1;
		 numTie=2;

		 //Gets higher handrank from others players
		for(i=1;i<NumPlayers;i++)
		{       
			Rank=rank5;
              j=i*2;
			 (Known[j])? Rank=HR[rank5+KnownCard[j]]  :     Rank=HR[rank5+Deck[c]],c++;
			 j++;
		     (Known[j])? Rank=HR[Rank+KnownCard[j]]   :    Rank=HR[Rank+Deck[c]],c++;
			 
        
              idwin=Rank>>12;

           //Debug
		     // printf("HandRank: %4.1d \n",idwin); 
            if (Rank>HighestRank)
			 {
				 idwinmax=idwin;
				 HighestRank=Rank;
				 numTie=2;
			 }	 
			 else if (Rank==HighestRank)
			 {
			   numTie++;
			   idwinmax=idwin;
			 } 
		}
	
	 
	    //Now compare higher player rank with mine
        Stat->OpponentHigherHand[idwinmax]++;
            
		if (myRank>HighestRank)//win
		{
			Stat->wins++;
			Stat->Odd++;
		}
		else if (myRank==HighestRank)//Tie
		{
            Stat->draws++;
			Stat->Odd=Stat->Odd+1/numTie;
		}
	 
	 
	 }//end simulation


	 
//       for(i=0;i<10;i++)
//       { mexPrintf("Stat->OpponentHigherHand[]= %4.2f\n",Stat->OpponentHigherHand[i]);}
//    
	


	//Deallocate Memory

	delete[] Known;
}


void ResetStat(Statistic* Stat)
{   //Reset all statstics values to zero
	int i;
	
	Stat->wins=0;
	Stat->draws=0;
	Stat->Odd=0;
	for (i=0;i<10;i++)
	{
		Stat->OpponentHigherHand[i]=0;
		Stat->PlayerHigherHand[i]=0;
	}
}






//void TestRandNumbers(int*p,int N)
//{
//	//counts frequency of random numbers
//	int j,i;
//   for(i=0;i<N;i++)
//   {
//	   j=p[i];
//	   TESTr[j]++;
//   }
//}





void NormalizeStat(Statistic* Stat,float Ns)
{    
	int i;
	//Normalize statistics depending on number of simulations
      // mexPrintf("Ns: %4.1f \n",Ns);  
       Ns=Ns/100;//to express the percentage
        //    mexPrintf("Ns: %4.1f \n",Ns); 
       
	  //mexPrintf("Stat->Odd: %4.1f \n",Stat->Odd);  
	   Stat->wins/=Ns;
	   Stat->draws/=Ns;
	   //Stat->Odd=(Ns*100)/Stat->Odd;//Odd=(simluations/wins)

	   //Now we use the Odd value to compute the maximumBet/pot ratio
       Stat->Odd/=Ns;
	   //Stat->Odd=Stat->Odd/(100-Stat->Odd); //La lasciamo calcolare al matlab


       //mexPrintf("Stat->Odd: %4.1f \n",Stat->Odd);  
       
	   for (i=1;i<10;i++)//Slatala prima che sono errori
	{
		Stat->OpponentHigherHand[i]/=Ns;
		Stat->PlayerHigherHand[i]/=Ns;
	   }
}





/* the gateway function */
//la chiamata deve essere :
//[PlayerStat,OpponenentStat,WinTieOdd]=GameSimulation(KnownCards,NumPlayers,NumSimulations,TablePtr)
//Errors flag:
// -2 Can not load table
// -1 Not enoguh memory



void mexFunction( int nlhs,const mxArray *plhs[3],
                  int nrhs,const mxArray *prhs[4] )
{
 
 //dichiarazioni variabili   
 int i;
 double* ptr; 
 
  if(nrhs!=4) 
    mexErrMsgTxt("4 inputs required.");
  if(nlhs!=3) 
    mexErrMsgTxt("Only 3 Outputs Supported");
  
       
    //Creazione Outputs
     plhs[0] = mxCreateDoubleMatrix(10,1,mxREAL);
     double* PlayerStat = mxGetPr(plhs[0]);
     
       plhs[1] = mxCreateDoubleMatrix(10,1,mxREAL);
     double* OpponentStat = mxGetPr(plhs[1]);
     
      plhs[2] = mxCreateDoubleMatrix(3,1,mxREAL);
     double* WinTieOdd = mxGetPr(plhs[2]);
  
   //Assegnazione inputs
     
     
     double* NumPlayers=mxGetPr(prhs[1]);
     double* NumSimulations=mxGetPr(prhs[2]);
    
     ptr=mxGetPr(prhs[3]);
     HR=(int*)((long)(ptr[0]));
     
      ptr=mxGetPr(prhs[0]);
     int* KnownCards= new int[(int)*NumPlayers*2+5];
     for(i=0;i<*NumPlayers*2+5;i++){KnownCards[i]=ptr[i];}
     
     
    if(HR==NULL)
    {
	    *ptr=-2;//can not load table
		return;
	}

     
//      mexPrintf("HR: %4.1d \n",HR[0]);   
//     mexPrintf("HR: %4.1d \n",HR[100]); 
//      mexPrintf("HR: %4.1d \n",HR[1000]); 
//      mexPrintf("HR: %4.1d \n",HR[10000]);
    
    Statistic Stat;//Build Statistics structure
    
    
    GameSimulation(KnownCards,*NumPlayers,*NumSimulations,&Stat);//Run Simulations
    
    
    NormalizeStat(&Stat,*NumSimulations);//Normalize statistcs
    
    //Copy in the Output array
    for(i=0;i<10;i++){PlayerStat[i]=Stat.PlayerHigherHand[i];}
    for(i=0;i<10;i++){OpponentStat[i]=Stat.OpponentHigherHand[i];}
    WinTieOdd[0]=Stat.wins;
    WinTieOdd[1]=Stat.draws;
    WinTieOdd[2]=Stat.Odd;
    
    
    
    
    //Deallocate memory
    delete [] KnownCards; 
     
}
